#!/bin/bash

# C 程序执行后有两个输出文件 library.dot 和 count.record
# library.dot 去重后，根据 count.record 记录将引用计数加上

today=`date +%Y-%m-%d-%H-%M`

function generate_input () {
	if [ -f linkfile ]; then
	    rm linkfile
	fi

	ps aux | awk -F' ' '{print $11}' | sed '/^\/usr/!d' > processfile

	cat processfile | while read line
	do
	    # 将实际链接的库路径保存
	    ldd $line | awk -F' ' '{print $3}' >> linkfile
	done

	#去重
	awk '!a[$0]++' linkfile > result.output
}

function handle_output() {
	# 去重
	if [ -f library.dot ];then
	    awk '!a[$0]++' library.dot > newlib.dot
	fi

	if [ ! -f newlib.dot ] || [ ! -f count.record ];then
	    echo "Exit! have no output file."
	    exit 1
	fi
	# 给树状图加上计数
	cat count.record | while read line
	do
	    libname=`echo $line | awk -F" " '{print $1}'`
	    echo $libname
	    sed -i "s/$libname/$line/g" newlib.dot
	done

	# 生成图
	dot -Tjpg newlib.dot -o library-$today.jpg

	# 库的引用计数排序文件，对比树状图来看
	awk -F"[()]" '{arr[$1] = $2} END { for (a in arr) print a, arr[a]}' count.record | sort -k 2 -nr > count.recordnew
}

dot=`rpm -qa | grep graphviz`

if [ -z "$dot" ];then
	echo "You should install graphviz first."
	exit 1
fi

handle_output
